<template>
    <div class="list-view">
        <page-title>
            <!-- <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button> -->
            <el-button
                @click="download"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData"
                class="filter-item"
            >
                导出
            </el-button>
        </page-title>
        <div class="filters-container">
            <created-at-picker v-model="createdAt" @input="getData" name="支付" class="filter-item"></created-at-picker>
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
            <el-select
                v-model="activity"
                placeholder="请选择活动"
                @change="getData"
                clearable
                filterable
                class="filter-item"
            >
                <el-option v-for="item in activities" :key="item.id" :value="item.id" :label="item.name">
                    <span style="float: left">{{ item.name }}</span>
                    <span style="float: right; color: #8492a6; font-size: 13px">#{{ item.id }}</span>
                </el-option>
            </el-select>
            <el-select
                v-model="status"
                placeholder="请选择状态"
                @change="getData"
                clearable
                filterable
                class="filter-item"
            >
                <el-option
                    v-for="item in statusOptions"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                ></el-option>
            </el-select>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="订单编号" width="80"> </el-table-column>
            <el-table-column prop="userId" label="用户ID" min-width="80"> </el-table-column>
            <el-table-column prop="phone" label="手机号" min-width="90"> </el-table-column>
            <el-table-column prop="mintActivityId" label="铸造活动ID" min-width="80"> </el-table-column>
            <el-table-column prop="mintActivity" label="活动名称" min-width="120"></el-table-column>
            <!-- <el-table-column prop="createdAt" label="铸造时间" min-width="120"> </el-table-column> -->
            <el-table-column prop="material" label="铸造材料详情" min-width="120">
                <template slot-scope="{ row }">
                    <span v-for="item in row.material" :key="item.assestId">{{ item.name }}<br /></span>
                </template>
            </el-table-column>
            <!-- <el-table-column prop="consume" label="消耗藏品" width="90" align="center">
                <template v-slot="{ row }">
                    <el-tag type="success" v-if="row.consume">是</el-tag>
                    <el-tag type="info" v-else>否</el-tag>
                </template>
            </el-table-column> -->
            <el-table-column label="收件人信息" min-width="120" show-overflow-tooltip>
                <template slot-scope="{ row }">
                    <span>{{ row.contactName }}</span>
                    <span style="margin-left: 10px">{{ row.contactPhone }}</span
                    ><br />
                    <span>{{ row.address }}</span>
                </template>
            </el-table-column>
            <el-table-column prop="payAt" label="支付时间" min-width="120" show-overflow-tooltip></el-table-column>
            <!-- <el-table-column prop="payMethod" label="支付方式" :formatter="payMethodFormatter"> </el-table-column> -->
            <el-table-column prop="gasPrice" label="gas费"> </el-table-column>
            <el-table-column prop="status" label="状态" :formatter="statusFormatter"> </el-table-column>
            <el-table-column label="操作" align="left" fixed="right" width="160">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                    <el-button @click="finish(row)" type="success" size="mini" plain v-if="row.status == 'AIR_DROP'"
                        >已空投</el-button
                    >
                    <el-button @click="delivery(row)" type="warning" size="mini" plain v-if="row.status == 'DELIVERY'"
                        >已发货</el-button
                    >
                    <el-button @click="finish(row)" type="success" size="mini" plain v-if="row.status == 'RECEIVE'"
                        >已收货</el-button
                    >

                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'MintOrderList',
    mixins: [pageableTable],
    created() {
        this.$http
            .post(
                '/mintActivity/all',
                {
                    sort: 'createdAt,desc',
                    query: { del: false }
                },
                { body: 'json' }
            )
            .then(res => {
                this.activities = res.content;
            });
    },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/mintOrder/all',
            downloading: false,
            payMethodOptions: [
                { label: '微信', value: 'WEIXIN' },
                { label: '支付宝', value: 'ALIPAY' }
            ],
            statusOptions: [
                { label: '未支付', value: 'NOT_PAID' },
                { label: '待发货', value: 'DELIVERY' },
                { label: '待收货', value: 'RECEIVE' },
                { label: '待空投', value: 'AIR_DROP' },
                { label: '已完成', value: 'FINISH' },
                { label: '已取消', value: 'CANCELLED' }
            ],
            createdAt: '',
            activities: [],
            activity: '',
            status: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        payMethodFormatter(row, column, cellValue, index) {
            let selectedOption = this.payMethodOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return {
                search: this.search,
                query: { del: false, payAt: this.createdAt, mintActivityId: this.activity, status: this.status }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/mintOrderEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/mintOrderEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            let params = this.beforeGetData();
            params.size = 10000;
            params.sort = 'createdAt,desc';
            this.$axios
                .post('/mintOrder/excelPhone', params, {
                    responseType: 'blob'
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', '铸造订单.xlsx');
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/mintOrder/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        finish(row) {
            this.$alert('确定此订单已空投完成？', '提示', { type: 'primary' })
                .then(() => {
                    return this.$http.get(`/mintOrder/finish/${row.id}`);
                })
                .then(() => {
                    this.$message.success('订单完成');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e.error);
                    }
                });
        },
        delivery(row) {
            this.$prompt('请输入快递单号', '快递单号', {
                confirmButtonText: '确定',
                cancelButtonText: '取消'
            })
                .then(({ value }) => {
                    return this.$http.get('/mintOrder/delivery', {
                        id: row.id,
                        courierId: value
                    });
                })
                .then(() => {
                    this.getData();
                })
                .catch(() => {
                    this.$message({
                        type: 'info',
                        message: '取消输入'
                    });
                });
        }
    }
};
</script>
<style lang="less" scoped>
</style>
